from imutils import face_utils
import random
import imutils
import cv2
import dlib

def is_collide(drawX,drawY,X,Y):
	print(drawX,drawY,X,Y)
	if abs(drawX-X) <= 10 and abs(drawY-Y) <= 10:
		return True
	return False


def draw(frame,x,y,color_index):
	color = colors[color_index]
	y = y
	cv2.circle(frame,(x,y),20,color,-1)



print("[INFO] Loading dlib...")
detector = dlib.get_frontal_face_detector()
predictor = dlib.shape_predictor("shape_predictor_68_face_landmarks.dat")

total_mark = 0

colors = [(0,0,255),(0,255,0),(255,0,0)]
x,y = 0,0
	
color_index = random.randint(0,2)
color_for_mark = random.randint(0,2)
draw_x = random.randint(200,400)
draw_y = 0

cam = cv2.VideoCapture(0)


while True:
	ret,frame = cam.read()
	frame = imutils.resize(frame,width=500)
	gray = cv2.cvtColor(frame, cv2.COLOR_BGR2GRAY)
	rects = detector(gray, 0)
 
	# loop over the face detections
	for (i, rect) in enumerate(rects):
		shape = predictor(gray, rect)
		shape = face_utils.shape_to_np(shape)
		(x,y) = shape[30]
		cv2.circle(frame,(x,y),20,colors[color_for_mark],-1)
	
	draw_y = draw_y + 10
	if is_collide(draw_x,draw_y,x,y):
		if color_index == color_for_mark:
			total_mark += 10
		else:
			total_mark -= 10
		draw_y = 0
		draw_x = random.randint(200,400)
		color_index = random.randint(0,2)
		color_for_mark = random.randint(0,2)
		
		continue

	if not draw_y >= frame.shape[0] - 100:
		draw(frame,draw_x,draw_y,color_index)
	else:
		draw_y = 0
		draw_x = random.randint(200,400)
		color_index = random.randint(0,2)

	frame = cv2.flip(frame,1)

	cv2.putText(frame, "Total Mark #{}".format(total_mark), (frame.shape[1]-300,20),
		cv2.FONT_HERSHEY_SIMPLEX, 1, (255, 255, 0), 2)

	
	cv2.imshow("Image",frame)

	key = cv2.waitKey(1) & 0xFF
	if key == ord('q'):
		break

cv2.destroyAllWindows()
cam.release()


